UnresolvedListElementWithLength (Apache FOP Core 2.11 API)
Date: 2025-04-24

org.apache.fop.layoutmgr

## Class UnresolvedListElementWithLength

- java.lang.Object
- - org.apache.fop.layoutmgr.ListElement
  - - org.apache.fop.layoutmgr.UnresolvedListElement
    - - org.apache.fop.layoutmgr.UnresolvedListElementWithLength

- Direct Known Subclasses:
    BorderOrPaddingElement, SpaceElement

      public abstract class UnresolvedListElementWithLength
      extends UnresolvedListElement

  This class represents an unresolved list element element with a (conditional) length. This is the base class for spaces, borders and paddings.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static org.apache.commons.logging.Log` | `log` Logger instance

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `UnresolvedListElementWithLength(Position position, MinOptMax length, RelSide side, boolean conditional, boolean isFirst, boolean isLast)` Main constructor

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `MinOptMax` | `getLength()`
    `RelSide` | `getSide()`
    `boolean` | `isConditional()`
    `boolean` | `isFirst()`
    `boolean` | `isLast()`
    `abstract void` | `notifyLayoutManager(MinOptMax effectiveLength)` Called to notify the affected layout manager about the effective length after resolution.
    `String` | `toString()`

    - ### Methods inherited from class org.apache.fop.layoutmgr.UnresolvedListElement

      `getOriginatingLayoutManager`

    - ### Methods inherited from class org.apache.fop.layoutmgr.ListElement

      `getLayoutManager, getPosition, isBox, isForcedBreak, isGlue, isPenalty, isUnresolvedElement, setPosition`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### log

          protected static final org.apache.commons.logging.Log log

      Logger instance

  - ### Constructor Detail

    - #### UnresolvedListElementWithLength

          public UnresolvedListElementWithLength(Position position,
                                                 MinOptMax length,
                                                 RelSide side,
                                                 boolean conditional,
                                                 boolean isFirst,
                                                 boolean isLast)

      Main constructor
      Parameters:
        `position` - the Position instance needed by the addAreas stage of the LMs.
        `length` - the length of the element
        `side` - the side to which this element applies
        `conditional` - true if it's a conditional element (conditionality=discard)
        `isFirst` - true if this is a space-before of the first area generated.
        `isLast` - true if this is a space-after of the last area generated.

  - ### Method Detail

    - #### isConditional

          public boolean isConditional()

      Specified by:
        `isConditional` in class `UnresolvedListElement`
      Returns:
        true if the element is conditional (conditionality="discard")

    - #### getLength

          public MinOptMax getLength()

      Returns:
        the space as resolved MinOptMax instance

    - #### getSide

          public RelSide getSide()

      Returns:
        the side this element was generated for

    - #### isFirst

          public boolean isFirst()

      Returns:
        true if this is a space-before of the first area generated.

    - #### isLast

          public boolean isLast()

      Returns:
        true if this is a space-after of the last area generated.

    - #### notifyLayoutManager

          public abstract void notifyLayoutManager(MinOptMax effectiveLength)

      Called to notify the affected layout manager about the effective length after resolution. This method is called once before each call to the layout manager's addAreas() method.
      Parameters:
        `effectiveLength` - the effective length after resolution (may be null which equals to zero effective length)

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2025 Apache Software Foundation. All rights reserved.